// no_alg.h :
// Needed just to simulate RL alg. when no RL alg is used

#include <cmath>

template  <class State,class Action>
class No_Alg : public Learning_Alg<State,Action> {
  int StepCount;
  double TotalRwd;

public:

  No_Alg () {
    StepCount = 0;
  }

  // Nothing to be done
  virtual void get_step (Action  stepAction,
                 State   nextState,
                 double  stepReward) {

    StepCount++;
    TotalRwd += stepReward;

  }

  virtual void start_run (State startState) {

    //Do nothing
  }

  virtual void finish_run () {

    //Do nothing
  }

  virtual void set_in_table (State stepState, Action stepAction) {

    //No need for it...??.
  }

  virtual void print_stats () {

    cout << "Average reward: " << TotalRwd/StepCount << "\n";
  }
};
